         title    HelpMenu

         .586
         .model   flat, STDCALL
         option   casemap: none   ; case sensitive

         include  AsmEdit.inc


.data
AppName        db      'AsmEdit V4.1',0
ListboxClass   db      'LISTBOX',0
szREGSZ        db      'REG_SZ',0
szMenuKey      db      '\Help Menu Items',0
szWorkKey      db      '\Work',0
szMenuCnt      db      'Menu Cnt',0
szName         db      'Menu '
szIndex        db      10 dup(?),0
fmat4          db      '%04u',0
szCol          db      ':',0
Patn           db      '*.*',0
szSep          db      '** Seperator **',0
szAddM         db      'Add A Menu Item',0
szEditM        db      'Edit The Menu Item',0
szGetHelp      db      'Get Help File',0
szSetup        db      'Missing entries!',0
szNoSel        db      'No item was selected.',0

.data?
szNameU        db      64  dup(?)
szBuffN        db      64  dup(?)
szBuffP        db      256 dup(?)
szPath         db      256 dup(?)
szMenuItems    db      256 dup(?)
szRegWork      db      256 dup(?)
lpType         dd      ?
hList          dd      ?
hKey           dd      ?
hKeyW          dd      ?
hList45        dd      ?
hSMenuH        dd      ?
mItem          dd      ?
uItem          dd      ?
hBR            dd      ?
hDlgSav        dd      ?
TempWord1      dd      ?
sw4            dd      ?

mii            MENUITEMINFO      <?>

.code

;=========================================================================
; Get menu path PROCEDURE
;=========================================================================
GetMenuPath  PROC  uses ebx esi edi RegKey:DWORD, wparam
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    Cnt:DWORD
LOCAL    szWork[256]:BYTE

         INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
            dec     eax
         INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
            mov     hSMenuH, eax

         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szMenuKey

;--------------- [Open or create the menu registry] --------------- 
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

         INVOKE     wsprintf, addr szIndex, addr fmat4, wparam
         INVOKE     lstrlen, addr szPath
            mov     lpcbData, 250
         INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
         .if eax == 0
               xor     eax, eax
               mov     ecx, 100
            .while (ecx)
               .if byte ptr szPath[eax] == ':'
                    push     eax
                     inc     eax
                  INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                     pop     eax
                     inc     eax
                  INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                  .break
               .endif
                  dec     ecx
                  inc     eax
            .endw
         .endif

GetOut:
      INVOKE     RegCloseKey, hKey
         lea     eax, szBuffP
         ret
GetMenuPath  ENDP

;=========================================================================
; Load menu items PROCEDURE
;=========================================================================
LoadMenuItems  PROC  uses ebx esi edi RegKey:DWORD, SubMenu
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    Cnt:DWORD
LOCAL    szWork[256]:BYTE

            mov     mii.cbSize, sizeof mii
            mov     mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE

         INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
            dec     eax
         INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
            mov     hSMenuH, eax

         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szMenuKey

;--------------- [Open or create the menu registry] --------------- 
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

            mov     lpcbData, 4
         INVOKE     RegQueryValueEx, hKey, addr szMenuCnt, 0, addr lpType, addr mItem, addr lpcbData
         .if eax != 0 || mItem == 7100
               jmp     GetOut
         .endif

          MOVmd     Cnt, mItem
            sub     Cnt, 7100
            mov     mItem, 7101
         .while (Cnt)
            INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
            INVOKE     lstrlen, addr szPath
               mov     lpcbData, 250
            INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
            .if eax == 0
                  xor     eax, eax
                  mov     ecx, 100
               .while (ecx)
                  .if byte ptr szPath[eax] == ':' || byte ptr szPath[eax] == '*' &&\
                      byte ptr szPath[eax+3] == 'S'
                     .if byte ptr szPath[eax] == ':'
                          push     eax
                           inc     eax
                        INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                           pop     eax
                           inc     eax
                        INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                     .else
                        INVOKE     lstrcpy, addr szBuffN, addr szPath
                     .endif
                     INVOKE     GetMenuItemCount, hSMenuH  ; Get count of items in the sub menu
                        sub     eax, 2
                        mov     ecx, eax
                     .if byte ptr szPath == '*'
                        INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_SEPARATOR, mItem, addr szBuffN
                     .else
                        INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_STRING, mItem, addr szBuffN
                     .endif
                     .break
                  .endif
                     dec     ecx
                     inc     eax
               .endw
            .endif
               inc     mItem
               dec     Cnt
         .endw

GetOut:
      INVOKE     RegCloseKey, hKey

         ret
LoadMenuItems  ENDP

;=========================================================================
; Customize menu PROCEDURE
;=========================================================================
MenuDlg  PROC  uses ebx esi edi  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    dItem:DWORD, Cnt
LOCAL    szWork[256]:BYTE

      .if wmsg == WM_INITDIALOG
          MOVmd     hDlgSav, hdlg

; WS_VISIBLE or
;---------- [Create the Listbox] ----------
         INVOKE     CreateWindowEx, WS_EX_TOPMOST, addr ListboxClass, 0, WS_CHILD or\
                    WS_VSCROLL or LBS_HASSTRINGS,\
                    522, 29, 400, 400, hWnd, 85, hInst, 0
            mov     hList, eax

            mov     mii.cbSize, sizeof mii
            mov     mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE

         INVOKE     lstrcpy, addr szMenuItems, lparam
         INVOKE     lstrcat, addr szMenuItems, addr szMenuKey
         INVOKE     lstrcpy, addr szRegWork, lparam
         INVOKE     lstrcat, addr szRegWork, addr szWorkKey

;--------------- [Open or create the menu and work registry] --------------- 
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szRegWork, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKeyW, addr lpdwDisp

         INVOKE     GetDlgItem, hdlg, 445      ; Get the handle of the Listbox
            mov     hList45, eax               ; Save it
         INVOKE     GetDlgItem, hdlg, 34       ; Get the handle of the Static ctl
         INVOKE     SetFocus, eax
         INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
            dec     eax
         INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
            mov     hSMenuH, eax

         INVOKE     GetMenuString, hSMenuH, IDM_WHELP, addr szWork, 255, MF_BYCOMMAND
         INVOKE     SendMessage, hList45, LB_ADDSTRING, 0, addr szWork
         INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szWork
            mov     lpcbData, 4
         INVOKE     RegQueryValueEx, hKey, addr szMenuCnt, 0, addr lpType, addr mItem, addr lpcbData
         .if eax != 0 || mItem == 7100
               mov     mItem, 7101
               jmp     MenuDone
         .endif

          MOVmd     Cnt, mItem
            sub     Cnt, 7100
            mov     mItem, 7101
         .while (Cnt)
            INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
            INVOKE     lstrlen, addr szPath
               mov     lpcbData, 250
            INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
            .if eax == 0
                  xor     eax, eax
                  mov     ecx, 100
               .while (ecx)
                  .if byte ptr szPath[eax] == ':' || byte ptr szPath[eax] == '*' &&\
                      byte ptr szPath[eax+3] == 'S'
                     .if byte ptr szPath[eax] == ':'
                          push     eax
                           inc     eax
                        INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                           pop     eax
                           inc     eax
                        INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                     .else
                        INVOKE     lstrcpy, addr szBuffN, addr szPath
                     .endif

                     INVOKE     SendMessage, hList45, LB_ADDSTRING, 0, addr szBuffN
                        mov     ecx, eax
                     INVOKE     SendMessage, hList45, LB_SETITEMDATA, ecx, mItem
   
                     INVOKE     lstrcpy, addr szWork, addr szName
                     INVOKE     lstrcat, addr szWork, addr szPath
                     INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szWork
                        mov     ecx, eax
                     INVOKE     SendMessage, hList, LB_SETITEMDATA, ecx, mItem

                     .break
                  .endif
                     dec     ecx
                     inc     eax
               .endw
            .endif
               inc     mItem
               dec     Cnt
         .endw



      .elseif wmsg == WM_CTLCOLORDLG 
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLORSTATIC
         INVOKE     GetDlgItem, hdlg, 34
         .if lparam != eax
            INVOKE     SetBkColor, wparam, 00ffffe0h
            INVOKE     SetTextColor, wparam, 00000000h
            .if hBR
               INVOKE     DeleteObject, hBR
            .endif
            INVOKE     CreateSolidBrush, 00ffffe0h
               mov     hBR, eax
         .else
            INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
            INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
            INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
         .endif
            ret

      .elseif wmsg == WM_CTLCOLORLISTBOX || wmsg == WM_CTLCOLOREDIT
         INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
         INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
         INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
            ret

      .elseif wmsg == WM_CLOSE

EndIt:
         INVOKE     RegCloseKey, hKey
         INVOKE     RegDeleteKey, HKEY_CURRENT_USER, offset szMenuItems
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

         INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
            mov     Cnt, eax
            mov     dItem, 1
            mov     mItem, 7101
         .if Cnt
               dec     Cnt
         .endif
         .while (Cnt)
            INVOKE     SendMessage, hList, LB_GETTEXT, dItem, addr szPath
            .if eax != LB_ERR
               INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
               INVOKE     lstrcpy, addr szPath, addr szPath+9
               INVOKE     lstrlen, addr szPath
                  mov     lpcbData, eax
               INVOKE     RegSetValueEx, hKey, addr szName, 0, REG_SZ, addr szPath, lpcbData
            .endif
               inc     dItem
               inc     mItem
               dec     Cnt
         .endw
         INVOKE     RegSetValueEx, hKey, addr szMenuCnt, 0, REG_DWORD, addr mItem, 4

         INVOKE     RegCloseKey, hKey
         INVOKE     RegCloseKey, hKeyW
         INVOKE     EndDialog, hdlg, 0
            mov     eax, TRUE
            jmp     MenuRet

      .elseif wmsg != WM_COMMAND
            jmp     MenuDone
      .endif

         mov     eax, wparam
        cwde
      .if eax == IDCANCEL || eax == B2
            jmp     EndIt

;---------- [Update or Add from MaintDlg] ----------
      .elseif eax == B1                ; Update or Add from MaintDlg
         .if sw4 == 15
               and     sw4, 0

            INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
            .if lparam == B4
               INVOKE     lstrcpy, addr szPath, addr szNameU
            .else
               INVOKE     lstrcpy, addr szPath, addr szName
            .endif
            INVOKE     lstrcat, addr szPath, addr szBuffN
            INVOKE     lstrcat, addr szPath, addr szCol
            INVOKE     lstrcat, addr szPath, addr szBuffP

;---------- [Update a menu item] ----------
            .if lparam == B4           ; Modify menu item
               INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
                  mov     dItem, eax
                  add     eax, 7100
                  mov     ecx, eax
                 push     ecx
                  mov     mii.fType, MFT_STRING
                  mov     mii.wID, ecx
                  mov     mii.dwTypeData, offset szBuffN
               INVOKE     SetMenuItemInfo, hSMenuH, ecx, FALSE, addr mii
               INVOKE     SendMessage, hList45, LB_DELETESTRING, dItem, 0
               INVOKE     SendMessage, hList45, LB_INSERTSTRING, dItem, addr szBuffN
               INVOKE     SendMessage, hList, LB_DELETESTRING, dItem, 0
               INVOKE     SendMessage, hList, LB_INSERTSTRING, dItem, addr szPath
                  pop     ecx
                 push     ecx
               INVOKE     SendMessage, hList45, LB_SETITEMDATA, dItem, ecx
                  pop     ecx
               INVOKE     wsprintf, addr szIndex, addr fmat4, ecx
   jmp     MenuDone
                  jmp     WritePath

;---------- [Insert a menu item] ----------
            .else                      ; Add menu item

Seperator:
               INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
                  inc     eax
                  mov     dItem, eax
               INVOKE     SendMessage, hList45, LB_INSERTSTRING, dItem, addr szBuffN
                  mov     ecx, eax
               INVOKE     SendMessage, hList45, LB_SETITEMDATA, ecx, mItem
               INVOKE     SendMessage, hList, LB_INSERTSTRING, dItem, addr szPath

               INVOKE     GetMenuItemCount, hSMenuH  ; Get count of items in the sub menu
                  sub     eax, 2
                  mov     ecx, dItem
                  add     ecx, 2
               .if ecx >= eax
                     mov     ecx, eax
               .endif
               .if lparam == B6
                  INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_SEPARATOR, mItem, addr szBuffN
               .else
                  INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_STRING, mItem, addr szBuffN
               .endif
                  inc     mItem
   jmp     MenuDone

               INVOKE     wsprintf, addr szIndex, addr fmat4, mItem

WritePath:      
;--------------- [Write the new path to the help menu registry] ---------------
               INVOKE     lstrcpy, addr szPath, addr szBuffN
               INVOKE     lstrcat, addr szPath, addr szCol
               INVOKE     lstrcat, addr szPath, addr szBuffP
               INVOKE     lstrlen, addr szPath
                  mov     lpcbData, eax
               INVOKE     RegSetValueEx, hKey, addr szName, 0, REG_SZ, addr szPath, lpcbData
               .if lparam == B3
                  INVOKE     RegSetValueEx, hKey, addr szMenuCnt, 0, REG_DWORD, addr mItem, 4
                     inc     mItem
               .endif
            .endif
            INVOKE     DrawMenuBar, hWnd
         .endif
            jmp     MenuDone

;---------- [Insert a seperator] ----------
      .elseif eax == B6                ; Seperator
         INVOKE     lstrcpy, addr szBuffN, addr szSep
         INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
         INVOKE     lstrcpy, addr szPath, addr szName
         INVOKE     lstrcat, addr szPath, addr szSep
            mov     lparam, B6
            jmp     Seperator

;---------- [Delate a menu item] ----------
      .elseif eax == B5                ; Remove
         INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
            cmp     eax, 0
             je     MenuDone
         .if eax == LB_ERR
            INVOKE     MessageBox, NULL, addr szNoSel, addr AppName, MB_OK or\
                       MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST
               jmp     MenuDone
         .endif
            mov     dItem, eax
;            add     eax, 7100
            add     eax, 2
            mov     ecx, eax
;         INVOKE     wsprintf, addr szIndex, addr fmat4, ecx
;         INVOKE     DeleteMenu, hSMenuH, ecx, MF_BYCOMMAND
         INVOKE     DeleteMenu, hSMenuH, ecx, MF_BYPOSITION
         INVOKE     SendMessage, hList45, LB_DELETESTRING, dItem, 0
         INVOKE     SendMessage, hList, LB_DELETESTRING, dItem, 0
;         INVOKE     RegDeleteValue, hKey, addr szName
      INVOKE     RegDeleteKey, hKey, offset szMenuItems

      .elseif eax > B2 && eax < B5
         .if eax == B4
            INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
               cmp     eax, 0
                je     MenuDone
            .if eax == LB_ERR
               INVOKE     MessageBox, NULL, addr szNoSel, addr AppName, MB_OK or\
                          MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST
                  jmp     MenuDone
            .endif
               mov     ecx, eax
            INVOKE     SendMessage, hList, LB_GETTEXT, ecx, addr szPath
            INVOKE     lstrcpyn, addr szNameU, addr szPath, 10
            INVOKE     lstrcpy, addr szPath, addr szPath+9

;            INVOKE     SendMessage, hList45, LB_GETITEMDATA, ecx, 0
;            INVOKE     wsprintf, addr szIndex, addr fmat4, eax
;            INVOKE     lstrlen, addr szPath
;               mov     lpcbData, 250
;            INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
               xor     eax, eax
               mov     ecx, 100
            .while (ecx)
               .if byte ptr szPath[eax] == ':'
                       push     eax
                        inc     eax
                     INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                        pop     eax
                        inc     eax
                     INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                   .break
               .endif
                  dec     ecx
                  inc     eax
            .endw
         .endif
            mov     ecx, offset MaintDlg
         INVOKE     CreateDialogParam, hInst, IDD_MAINTMENU, hWnd, ecx, wparam
      .endif

MenuDone:
         mov     eax, FALSE

MenuRet:
         ret
MenuDlg ENDP

;=========================================================================
; Maint menu PROCEDURE
;=========================================================================
MaintDlg  PROC  uses ebx esi edi  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    ofn:OPENFILENAME
LOCAL    pt:POINT
LOCAL    szSetUp[256]:BYTE, szWork[256], CurDir[256]

      .if wmsg == WM_INITDIALOG
          MOVmd     TempWord1, lparam
         .if lparam == B3
            INVOKE     SetWindowText, hdlg, addr szAddM
         .elseif lparam == B4
            INVOKE     SetWindowText, hdlg, addr szEditM
            INVOKE     SetDlgItemText, hdlg, E1, addr szBuffN
            INVOKE     SetDlgItemText, hdlg, E2, addr szBuffP
            INVOKE     GetDlgItem, hdlg, E2      ; Get the handle of the Edit ctl
               mov     ecx, eax
;            INVOKE     SendMessage, ecx, EM_SETSEL, -1, 0
            INVOKE     SetFocus, ecx
         .endif

      .elseif wmsg == WM_CTLCOLORDLG 
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLORSTATIC
         INVOKE     SetBkColor, wparam, 00ffffe0h
         INVOKE     SetTextColor, wparam, 00000000h
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLOREDIT
         INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
         INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
         INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
            ret

      .elseif wmsg == WM_CLOSE

EndIt:
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     SendMessage, hDlgSav, WM_COMMAND, B1, TempWord1
         INVOKE     EndDialog, hdlg, 0
            mov     eax, TRUE
            jmp     MaintRet

      .elseif wmsg != WM_COMMAND
            jmp     MaintDone
      .endif

         mov     eax, wparam
        cwde
      .if eax == IDCANCEL
            jmp     EndIt

      .elseif eax == B2
         INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
            mov     ofn.lStructSize, sizeof ofn
         INVOKE     lstrcpy, addr szSetUp, addr Patn
         INVOKE     GetCurrentDirectory, lengthof CurDir, addr CurDir
            lea     eax, szSetUp
            mov     ofn.lpstrFile, eax
            mov     ofn.nMaxFile, lengthof szSetUp
            lea     eax, CurDir
            mov     ofn.lpstrInitialDir, eax ;addr CurDir
            mov     ofn.lpstrFilter, 0
            mov     ofn.lpstrTitle, offset szGetHelp
            mov     ofn.Flags, OFN_NOVALIDATE
         INVOKE     GetOpenFileName, addr ofn
            cmp     eax, FALSE         ; Cancel'ed or error occurred
             je     MaintDone
         INVOKE     SetDlgItemText, hdlg, E2, ofn.lpstrFile
            jmp     MaintDone

      .elseif eax == B3
            and     sw4, 0
         INVOKE     GetDlgItemText, hdlg, E1, addr szBuffN, 250
         .if !eax
               jmp     ErrMsg
         .endif
         INVOKE     GetDlgItemText, hdlg, E2, addr szBuffP, 250
         .if !eax
               jmp     ErrMsg
         .endif
            mov     sw4, 15
            jmp     EndIt

      .else
            jmp     MaintDone
      .endif

ErrMsg:
      INVOKE     MessageBox, NULL, addr szSetup, addr AppName, MB_OK or\
                 MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST

MaintDone:
         mov     eax, FALSE

MaintRet:
         ret

MaintDlg ENDP

         END
;INVOKE     MessageBox, NULL, addr szBuff, addr AppName, MB_OK
