         title    HelpMenu

         .586
         .model   flat, STDCALL
         option   casemap: none   ; case sensitive

         include  AsmEdit.inc


.data
AppName        db      'AsmEdit V4.1',0
ListboxClass   db      'LISTBOX',0
szREGSZ        db      'REG_SZ',0
szMenuKey      db      '\Help Menu Items',0
szUserKey      db      '\User Defined Names',0
szAddinKey     db      '\User Addin Items',0

szWorkKey      db      '\Work',0

szMenuCnt      db      'Menu Cnt',0
szName         db      'Menu '
szIndex        db      10 dup(?),0
fmat4          db      '%04u',0
szCar          db      '^',0
szCol          db      ':',0
szColSp        db      ': ',0
szSpaces       db      '      ',0
Patn           db      '*.*',0
szUserK        db      '1c01',0
szUserK31      db      '1c31',0
szUserCode     db      'User Defined Code 1u01',0
szSep          db      '**** Seperator ****',0
szSub          db      'SUBMENU: ',0
szAddM         db      'Add A Menu Item',0
szEditM        db      'Edit The Menu Item',0
szGetHelp      db      'Get Help File',0
szSetup        db      'Missing entries!',0
szNoSel        db      'No item was selected.',0

.data?
szNameU        db      64  dup(?)
szBuffN        db      64  dup(?)
szBuffF        db      64 dup(?)
szBuffW        db      64 dup(?)
szBuffP        db      256 dup(?)
szPath         db      256 dup(?)
szMenuItems    db      256 dup(?)
lpType         dd      ?
hList          dd      ?
hKey           dd      ?
hDLG           dd      ?
hList45        dd      ?
h34            dd      ?
hSMenuH        dd      ?
hSubMenu       dd      ?
mItem          dd      ?
uItem          dd      ?
hBR            dd      ?
hDlgSav        dd      ?
TempWord1      dd      ?
Opt            dd      ?
;HelpOn         dd      ?
;AddinOn        dd      ?
;UserOn         dd      ?
sw4            dd      ?
sw5            dd      ?

mii            MENUITEMINFO      <?>

.code

;=========================================================================
; Get menu path PROCEDURE
;=========================================================================
GetMenuPath  PROC  uses ebx esi edi RegKey:DWORD, wparam, Code
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    Cnt:DWORD, Incr
LOCAL    szWork[256]:BYTE

      INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
         sub     eax, Code
      INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
         mov     hSMenuH, eax

      .if Code == 1
         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szMenuKey
      .else
         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szAddinKey
      .endif

;--------------- [Open or create the menu registry] --------------- 
      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

      INVOKE     wsprintf, addr szIndex, addr fmat4, wparam
      INVOKE     lstrlen, addr szPath
         mov     lpcbData, 250
      INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
      .if eax == 0
         INVOKE     lstrlen, addr szPath
         .if byte ptr szPath[eax-1] == '^'
               mov     byte ptr szPath[eax-1], 0
         .endif
            mov     ecx, eax
            xor     esi, esi
            xor     edi, edi
            lea     edx, szBuffN
            and     Incr, 0
         .while (ecx)
               mov     al, byte ptr szPath[esi]
            .if al == ':' && byte ptr szPath[esi+1] != '\'
                  mov     byte ptr [edx+edi], 0
                  xor     edi, edi
                  inc     Incr
               .if Incr == 1
                     lea     edx, szBuffP
               .elseif Incr == 2
                     lea     edx, szBuffF
               .elseif Incr == 3
                     lea     edx, szBuffW
               .else
                  .break
               .endif
            .else
                  mov     byte ptr [edx+edi], al
                  inc     edi
            .endif
               inc     esi
               dec     ecx
         .endw
            mov     byte ptr [edx+edi], 0
      .endif

GetOut:
      INVOKE     RegCloseKey, hKey

         ret
GetMenuPath  ENDP

;=========================================================================
; Load menu items PROCEDURE
;=========================================================================
LoadMenuItems  PROC  uses ebx esi edi RegKey:DWORD, SubMenu
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    Cnt:DWORD, Incr, Fill, PopupM
LOCAL    szWork[256]:BYTE, Misc[64]:BYTE

         and     Fill, 0
      .if SubMenu == 4
            jmp     ClearMenus
      .endif

      INVOKE     lstrcpy, addr szMenuItems, RegKey
      INVOKE     lstrcat, addr szMenuItems, addr szUserKey

;--------------- [Open or create the user name registry] --------------- 
      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp
         mov     Cnt, 0
         mov     lpcbData, 63
      INVOKE     RegQueryValueEx, hKey, addr szUserK, 0, addr lpType, addr szNameU, addr lpcbData
      .if eax == ERROR_SUCCESS
            mov     lpcbData, 63
         INVOKE     RegQueryValueEx, hKey, addr szUserK31, 0, addr lpType, addr szNameU, addr lpcbData
         .if eax != ERROR_SUCCESS
               mov     Cnt, 10
               mov     Incr, 31
         .endif
      .else
           mov     Cnt, 40
           mov     Incr, 1
      .endif

;--------------- [Fill the user code name registry if empty] --------------- 
      .if Cnt
         .while (Cnt)
            INVOKE     BaseAscii, Incr, addr Misc, 2, 10, 0, 1, 0
               mov     al, byte ptr Misc
               mov     byte ptr szUserK+2, al
               mov     byte ptr szUserCode+20, al
               mov     al, byte ptr Misc+1
               mov     byte ptr szUserK+3, al
               mov     byte ptr szUserCode+21, al
            INVOKE     lstrlen, addr szUserCode
               mov     lpcbData, eax
            INVOKE     RegSetValueEx, hKey, addr szUserK, 0, REG_SZ, addr szUserCode, lpcbData
               inc     Incr
               dec     Cnt
         .endw
      .endif
      INVOKE     RegCloseKey, hKey


         mov     mii.cbSize, sizeof mii
         mov     mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE

LoadMenus:
      INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
      .if !Fill
            dec     eax
      .else
            sub     eax, 3
      .endif
      INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
         mov     hSMenuH, eax

      .if !Fill
         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szMenuKey
      .else
         INVOKE     lstrcpy, addr szMenuItems, RegKey
         INVOKE     lstrcat, addr szMenuItems, addr szAddinKey
      .endif

;--------------- [Open or create the menu registry] --------------- 
      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

         mov     lpcbData, 4
      INVOKE     RegQueryValueEx, hKey, addr szMenuCnt, 0, addr lpType, addr mItem, addr lpcbData
      .if eax != 0 || mItem == 3100 || mItem == 7100
            jmp     GetOut
      .endif
         jmp     Pass

ClearMenus:
         and     PopupM, 0
         and     Incr, 0
      INVOKE     GetMenuItemCount, hSMenuH
         mov     Cnt, eax
;       MOVmd     Cnt, mItem
push     mItem
      .if mItem < 7100
            dec     Cnt
            mov     Incr, 1
            mov     mItem, 3101
            mov     Opt, 1
      .else
            sub     Cnt, 5
            mov     Incr, 3
            mov     mItem, 7101
            mov     Opt, 2
      .endif
      .while (Cnt)
         INVOKE     DeleteMenu, hSMenuH, Incr, MF_BYPOSITION
            dec     Cnt
            inc     mItem
      .endw
         inc     mItem
pop     mItem

Pass:
       MOVmd     Cnt, mItem
      .if Cnt < 7100
            sub     Cnt, 3100
            mov     mItem, 3101
            mov     Opt, 1
      .else
            sub     Cnt, 7100
            mov     mItem, 7101
            mov     Opt, 2
      .endif
      .while (Cnt)
         INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
         INVOKE     lstrlen, addr szPath
            mov     lpcbData, 250
         INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
         .if eax == 0
            .if byte ptr szPath == '*' && byte ptr szPath+3 == 'S'
               INVOKE     lstrcpy, addr szPath, addr szSep
            .endif
               xor     eax, eax
               mov     ecx, 150
            .while (ecx)
               .if byte ptr szPath[eax] == ':' || byte ptr szPath[eax] == '*' &&\
                   byte ptr szPath[eax+5] == 'S' || byte ptr szPath[eax] == 'S' &&\
                   byte ptr szPath[eax+2] == 'B' && byte ptr szPath[eax+7] == ':'
                  .if byte ptr szPath[eax] == ':'
                       push     eax
                        inc     eax
                     INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                        pop     eax
                        inc     eax
                     INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                  .elseif byte ptr szPath[eax+2] == 'B' && byte ptr szPath[eax+7] == ':'
                     INVOKE     lstrcpy, addr szBuffN, addr szPath+9
                     INVOKE     CreatePopupMenu
                        mov     hSubMenu, eax
                        mov     PopupM, 1

                  .else
                     INVOKE     lstrcpy, addr szBuffN, addr szPath
                  .endif

                   push     hSMenuH
                  INVOKE     lstrlen, addr szPath
                  .if byte ptr szPath[eax-1] == '^'
                       push     hSubMenu
                        pop     hSMenuH
                  .endif

                  INVOKE     GetMenuItemCount, hSMenuH  ; Get count of items in the sub menu
                  .if eax == -1
                        mov     eax, 0
                  .endif
                  .if Opt == 2
                        sub     eax, 2
                  .endif
                     mov     ecx, eax
                  .if byte ptr szPath == '*'
                     INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_SEPARATOR, mItem, addr szBuffN
                  .elseif PopupM
                     INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or\
                                MF_STRING or MF_POPUP, hSubMenu, addr szBuffN
                  .else
                     INVOKE     InsertMenu, hSMenuH, ecx, MF_BYPOSITION or MF_STRING, mItem, addr szBuffN
                  .endif
                     and     PopupM, 0
                     pop     hSMenuH
                  .break
               .endif
                  dec     ecx
                  inc     eax
            .endw
         .endif
            inc     mItem
            dec     Cnt
      .endw
      .if SubMenu == 1 && !Fill
         INVOKE     RegCloseKey, hKey
            inc     Fill
            jmp     LoadMenus
      .endif

GetOut:
      .if SubMenu == 4
            ret
      .endif

      INVOKE     RegCloseKey, hKey

         ret
LoadMenuItems  ENDP

;=========================================================================
; Customize menu PROCEDURE
;=========================================================================
MenuDlg  PROC  uses ebx esi edi  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    dItem:DWORD, Cnt, Incr
LOCAL    szWork[256]:BYTE, Misc[64]:BYTE

      .if wmsg == WM_INITDIALOG
          MOVmd     hDlgSav, hdlg
         .if Opt == 3 ;UserOn
            INVOKE     GetDlgItem, hdlg, 445      ; Get the handle of the Listbox
               mov     hList45, eax               ; Save it
            INVOKE     GetDlgItem, hdlg, 34       ; Get the handle of the Static ctl
               mov     h34, eax
            INVOKE     SetFocus, eax
            INVOKE     lstrcpy, addr szMenuItems, lparam
            INVOKE     lstrcat, addr szMenuItems, addr szUserKey

;--------------- [Open or create the user name registry] --------------- 
            INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                       KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

;--------------- [Fill the Listbox with user code names] --------------- 
               mov     Cnt, 40
               mov     Incr, 1
            .while (Cnt)
               INVOKE     BaseAscii, Incr, addr Misc, 2, 10, 0, 1, 0
                  mov     al, byte ptr Misc
                  mov     byte ptr szUserK+2, al
                  mov     al, byte ptr Misc+1
                  mov     byte ptr szUserK+3, al
                  mov     lpcbData, 63
               INVOKE     RegQueryValueEx, hKey, addr szUserK, 0, addr lpType, addr szNameU, addr lpcbData
               INVOKE     lstrcpy, addr szBuffP, addr szUserK
               INVOKE     lstrcat, addr szBuffP, addr szColSp
               INVOKE     lstrcat, addr szBuffP, addr szNameU
mov     byte ptr szBuffP+1, 'u'
               INVOKE     SendMessage, hList45, LB_ADDSTRING, 0, addr szBuffP
                  inc     Incr
                  dec     Cnt
            .endw
               jmp     MenuDone
         .endif

; WS_VISIBLE or
;---------- [Create a hidden work Listbox] ----------
         INVOKE     CreateWindowEx, WS_EX_TOPMOST, addr ListboxClass, 0, WS_CHILD or\
                    WS_VSCROLL or LBS_HASSTRINGS,\
                    522, 29, 400, 400, hWnd, 85, hInst, 0
            mov     hList, eax

            mov     mii.cbSize, sizeof mii
            mov     mii.fMask, MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE

         .if Opt == 1
            INVOKE     lstrcpy, addr szMenuItems, lparam
            INVOKE     lstrcat, addr szMenuItems, addr szAddinKey
         .elseif Opt == 2
            INVOKE     lstrcpy, addr szMenuItems, lparam
            INVOKE     lstrcat, addr szMenuItems, addr szMenuKey
         .else
               jmp     MenuDone
         .endif

;--------------- [Open or create the menu and work registry] --------------- 
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

         INVOKE     GetDlgItem, hdlg, 445      ; Get the handle of the Listbox
            mov     hList45, eax               ; Save it
         INVOKE     GetDlgItem, hdlg, 34       ; Get the handle of the Static ctl
         INVOKE     SetFocus, eax
         INVOKE     GetMenuItemCount, hMenu    ; Get count of items in the menu bar
         .if Opt == 1
               sub     eax, 3
         .else
               dec     eax
         .endif
         INVOKE     GetSubMenu, hMenu, eax     ; Get handle to last submenu
            mov     hSMenuH, eax

         .if Opt == 1
            INVOKE     GetMenuString, hSMenuH, IDM_ADDIN, addr szWork, 255, MF_BYCOMMAND
         .else
            INVOKE     GetMenuString, hSMenuH, IDM_WHELP, addr szWork, 255, MF_BYCOMMAND
         .endif
         INVOKE     SendMessage, hList45, LB_ADDSTRING, 0, addr szWork
         INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szWork
            mov     lpcbData, 4
         INVOKE     RegQueryValueEx, hKey, addr szMenuCnt, 0, addr lpType, addr mItem, addr lpcbData
         .if eax != 0 || mItem == 3100 || mItem == 7100
            .if Opt == 1
                  mov     mItem, 3101
            .else
                  mov     mItem, 7101
            .endif
               jmp     MenuDone
         .endif

          MOVmd     Cnt, mItem
         .if Cnt < 7100
               sub     Cnt, 3100
               mov     mItem, 3101
         .else
               sub     Cnt, 7100
               mov     mItem, 7101
         .endif
         .while (Cnt)
            INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
            INVOKE     lstrlen, addr szPath
               mov     lpcbData, 250
            INVOKE     RegQueryValueEx, hKey, addr szName, 0, addr lpType, addr szPath, addr lpcbData
            .if eax == 0
               .if byte ptr szPath == '*' && byte ptr szPath+3 == 'S'
                  INVOKE     lstrcpy, addr szPath, addr szSep
               .endif
                  xor     eax, eax
                  mov     ecx, 150
               .while (ecx)
                  .if byte ptr szPath[eax] == ':' || byte ptr szPath[eax] == '*' &&\
                      byte ptr szPath[eax+5] == 'S' || byte ptr szPath[eax] == 'S' &&\
                      byte ptr szPath[eax+2] == 'B' && byte ptr szPath[eax+7] == ':'
                     .if byte ptr szPath[eax] == ':'

                          push     eax
                           inc     eax
                        INVOKE     lstrcpyn, addr szBuffN, addr szPath, eax
                           pop     eax
                           inc     eax
                        INVOKE     lstrcpy, addr szBuffP, addr szPath[eax]
                     .elseif byte ptr szPath[eax+2] == 'B' && byte ptr szPath[eax+7] == ':'
                        INVOKE     lstrcpy, addr szBuffN, addr szPath ;+9
                     .else
                        INVOKE     lstrcpy, addr szBuffN, addr szPath
                     .endif
                     INVOKE     lstrlen, addr szPath
                     .if byte ptr szPath[eax-1] == '^'
                        INVOKE     lstrcpy, addr szWork, addr szSpaces
                        INVOKE     lstrcat, addr szWork, addr szBuffN
                        .if byte ptr szBuffN == '*'
                           INVOKE     lstrlen, addr szWork
                           INVOKE     lstrcpyn, addr szWork, addr szWork, eax
                        .endif
                        INVOKE     lstrcpy, addr szBuffN, addr szWork
                     .endif
                     INVOKE     SendMessage, hList45, LB_ADDSTRING, 0, addr szBuffN
                        mov     ecx, eax
                     INVOKE     SendMessage, hList45, LB_SETITEMDATA, ecx, mItem
   
                     INVOKE     lstrcpy, addr szWork, addr szName
                     INVOKE     lstrcat, addr szWork, addr szPath
                     INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szWork
                     .break
                  .endif
                     dec     ecx
                     inc     eax
               .endw
            .endif
               inc     mItem
               dec     Cnt
         .endw

      .elseif wmsg == WM_CTLCOLORDLG 
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLORSTATIC
         INVOKE     GetDlgItem, hdlg, 34
         .if lparam != eax
            INVOKE     SetBkColor, wparam, 00ffffe0h
            INVOKE     SetTextColor, wparam, 00000000h
            .if hBR
               INVOKE     DeleteObject, hBR
            .endif
            INVOKE     CreateSolidBrush, 00ffffe0h
               mov     hBR, eax
         .else
            INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
            INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
            INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
         .endif
            ret

      .elseif wmsg == WM_CTLCOLORLISTBOX || wmsg == WM_CTLCOLOREDIT
         INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
         INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
         INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
            ret

      .elseif wmsg == WM_CLOSE

EndIt:
;---------- [Delete and rewrite the menu registry] ----------
         .if Opt != 3 ;!UserOn        ; User code names
              call     ReWrite
         .endif
;            and     UserOn, 0
            and     Opt, 0
         INVOKE     RegCloseKey, hKey
         INVOKE     EndDialog, hdlg, 0
            mov     eax, TRUE
            jmp     MenuRet

      .elseif wmsg != WM_COMMAND
            jmp     MenuDone
      .endif

         mov     eax, wparam
        cwde
      .if eax == IDCANCEL || eax == B2
            jmp     EndIt

;---------- [Update or Add from MaintDlg] ----------
      .elseif eax == B1                ; Update or Add from MaintDlg
         INVOKE     SetFocus, h34
         .if sw4 == 15
               and     sw4, 0

            .if Opt == 3 ;UserOn
               INVOKE     lstrcpy, addr szPath, addr szBuffN
               INVOKE     lstrcat, addr szPath, addr szColSp
               INVOKE     lstrcat, addr szPath, addr szBuffP
            .else
               INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
               .if lparam == B4
                  INVOKE     lstrcpy, addr szPath, addr szNameU
               .else
                  INVOKE     lstrcpy, addr szPath, addr szName
               .endif
               INVOKE     lstrcat, addr szPath, addr szBuffN
               .if lparam != B7 && lparam != B8
                  INVOKE     lstrcat, addr szPath, addr szCol
                  INVOKE     lstrcat, addr szPath, addr szBuffP
                  .if Opt == 1
                     INVOKE     lstrcat, addr szPath, addr szCol
                     INVOKE     lstrcat, addr szPath, addr szBuffF
                     INVOKE     lstrcat, addr szPath, addr szCol
                     INVOKE     lstrcat, addr szPath, addr szBuffW
                  .endif
               .endif
            .endif

;---------- [Update a menu item] ----------
            .if lparam == B4 || lparam == B8          ; Modify menu item
               INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
                  mov     dItem, eax
               .if Opt == 3 ;UserOn
                  INVOKE     SendMessage, hList45, LB_DELETESTRING, dItem, 0
                  INVOKE     SendMessage, hList45, LB_INSERTSTRING, dItem, addr szPath
mov     byte ptr szBuffN+1, 'c'
                  INVOKE     RegSetValueEx, hKey, addr szBuffN, 0, REG_SZ, addr szBuffP, lpcbData
               .else
                  INVOKE     lstrlen, addr szPath
                  .if byte ptr szPath[eax-1] == '^'
;                     INVOKE     lstrcat, addr szBuffN, addr szCar
                     INVOKE     lstrcpy, addr szWork, addr szSpaces
                     INVOKE     lstrcat, addr szWork, addr szBuffN
                     INVOKE     lstrcpy, addr szBuffN, addr szWork
                  .endif
                  INVOKE     SendMessage, hList45, LB_DELETESTRING, dItem, 0
                  INVOKE     SendMessage, hList45, LB_INSERTSTRING, dItem, addr szBuffN
                  INVOKE     SendMessage, hList, LB_DELETESTRING, dItem, 0
                  INVOKE     SendMessage, hList, LB_INSERTSTRING, dItem, addr szPath
                    push     mItem
                    call     ReWrite
                     pop     mItem
               .endif
                  jmp     MenuDone

;---------- [Insert a menu item] ----------
            .else                      ; Add menu item

Seperator:
               INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
                  mov     ecx, eax
                  inc     eax
                 push     eax
                  mov     dItem, eax
               INVOKE     SendMessage, hList45, LB_GETTEXT, ecx, addr szWork
               .if byte ptr szWork == 'S' && byte ptr szWork+2 == 'B' &&\
                   byte ptr szWork+7 == ':'
                  INVOKE     lstrcat, addr szPath, addr szCar
                     pop     eax
               .else
                     pop     ecx
                  INVOKE     SendMessage, hList, LB_GETTEXT, ecx, addr szWork
                  .if byte ptr szWork[eax-1] == '^'
                     INVOKE     lstrcat, addr szPath, addr szCar
                  .endif
               .endif

               INVOKE     lstrlen, addr szPath
               .if byte ptr szPath[eax-1] == '^'
                  INVOKE     lstrcpy, addr szWork, addr szSpaces
                  INVOKE     lstrcat, addr szWork, addr szBuffN
                  INVOKE     lstrcpy, addr szBuffN, addr szWork
               .endif

               INVOKE     SendMessage, hList45, LB_INSERTSTRING, dItem, addr szBuffN
                  mov     ecx, eax
               INVOKE     SendMessage, hList45, LB_SETITEMDATA, ecx, mItem
               INVOKE     SendMessage, hList, LB_INSERTSTRING, dItem, addr szPath
                 push     mItem
                 call     ReWrite
                  pop     mItem
                  inc     mItem
            .endif
            INVOKE     DrawMenuBar, hWnd
         .endif
            jmp     MenuDone

;---------- [Insert a seperator] ----------
      .elseif eax == B6                ; Seperator
         INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
         .if eax == LB_ERR
            INVOKE     MessageBox, NULL, addr szNoSel, addr AppName, MB_OK or\
                       MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST
            INVOKE     SetFocus, h34
               jmp     MenuDone
         .endif
           push     eax
         INVOKE     lstrcpy, addr szBuffN, addr szSep
         INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
         INVOKE     lstrcpy, addr szPath, addr szName
         INVOKE     lstrcat, addr szPath, addr szSep
            pop     ecx
            inc     ecx
;         INVOKE     SendMessage, hList, LB_GETTEXT, ecx, addr szWork
;         .if byte ptr szWork[eax-1] == '^'
;            INVOKE     lstrcat, addr szPath, addr szCar
;         .endif
            mov     lparam, B6
            jmp     Seperator

;---------- [Delate a menu item] ----------
      .elseif eax == B5                ; Remove
         INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
            cmp     eax, 0
             je     MenuDone
         .if eax == LB_ERR
            INVOKE     MessageBox, NULL, addr szNoSel, addr AppName, MB_OK or\
                       MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST
            INVOKE     SetFocus, h34
               jmp     MenuDone
         .endif
            mov     dItem, eax
         INVOKE     SendMessage, hList45, LB_DELETESTRING, dItem, 0
         INVOKE     SendMessage, hList, LB_DELETESTRING, dItem, 0
           push     mItem
           call     ReWrite
            pop     mItem

;---------- [Call MaintDlg for Add or Update] ----------
      .elseif eax == B3 || eax == B4 || eax == B7
         INVOKE     SendMessage, hList45, LB_GETCURSEL, 0, 0
         .if wparam == B4 && Opt != 3
               cmp     eax, 0
                je     MenuDone
         .endif
         .if wparam == B7 && Opt == 3
               jmp     MenuDone
         .endif
         .if eax == LB_ERR
            INVOKE     MessageBox, NULL, addr szNoSel, addr AppName, MB_OK or\
                       MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST
            INVOKE     SetFocus, h34
               jmp     MenuDone
         .endif

         .if wparam == B4 || wparam == B7
            .if Opt == 3
                  mov     ecx, eax
               INVOKE     SendMessage, hList45, LB_GETTEXT, ecx, addr szPath
               INVOKE     lstrcpyn, addr szBuffN, addr szPath, 5
               INVOKE     lstrcpy, addr szBuffP, addr szPath+6
                  mov     ecx, offset MaintDlg
               INVOKE     CreateDialogParam, hInst, IDD_USERNAMEU, hWnd, ecx, wparam
                  jmp     MenuDone
            .endif

               mov     ecx, eax
            INVOKE     SendMessage, hList, LB_GETTEXT, ecx, addr szPath
            .if byte ptr szPath+9 == '*' && byte ptr szPath+14 == 'S' && wparam == B4
                  jmp     MenuDone
            .endif

            .if byte ptr szPath+9 == 'S' && byte ptr szPath+11 == 'B' &&\
                byte ptr szPath+16 == ':'
               INVOKE     lstrcpy, addr szBuffN, addr szPath+18
                  mov     wparam, B8
                  jmp     GetOut
            .else
               INVOKE     lstrcpyn, addr szNameU, addr szPath, 10
               INVOKE     lstrcpy, addr szPath, addr szPath+9
            .endif

            INVOKE     lstrlen, addr szPath
               mov     ecx, eax
               xor     esi, esi
               xor     edi, edi
               lea     edx, szBuffN
               and     Incr, 0
            .while (ecx)
                  mov     al, byte ptr szPath[esi]
               .if al == ':' && byte ptr szPath[esi+1] != '\'
                     mov     byte ptr [edx+edi], 0
                     xor     edi, edi
                     inc     Incr
                  .if Incr == 1
                        lea     edx, szBuffP
                  .elseif Incr == 2
                        lea     edx, szBuffF
                  .elseif Incr == 3
                        lea     edx, szBuffW
                  .else
                     .break
                  .endif
               .else
                     mov     byte ptr [edx+edi], al
                     inc     edi
               .endif
                  inc     esi
                  dec     ecx
            .endw
               mov     byte ptr [edx+edi], 0
         .endif

GetOut:
            mov     ecx, offset MaintDlg
         .if wparam != B7 && wparam != B8
            .if Opt == 1
               INVOKE     CreateDialogParam, hInst, IDD_MAINTPOP, hWnd, ecx, wparam
            .else
               INVOKE     CreateDialogParam, hInst, IDD_MAINTMENU, hWnd, ecx, wparam
            .endif
         .else
            INVOKE     CreateDialogParam, hInst, IDD_MAINTSUB, hWnd, ecx, wparam
         .endif
      .endif

MenuDone:
         mov     eax, FALSE

MenuRet:
         ret
MenuDlg ENDP

;=========================================================================
; Maint menu PROCEDURE
;=========================================================================
MaintDlg  PROC  uses ebx esi edi  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    ofn:OPENFILENAME
LOCAL    szSetUp[256]:BYTE, szWork[256], CurDir[256]

      .if wmsg == WM_INITDIALOG
          MOVmd     hDLG, hdlg
          MOVmd     TempWord1, lparam

         .if lparam == B3
            INVOKE     SetWindowText, hdlg, addr szAddM

         .elseif lparam == B4 || lparam == B8
            .if Opt != 3 && lparam != B8
               INVOKE     SetWindowText, hdlg, addr szEditM
            .endif
               and     sw5, 0
            INVOKE     lstrlen, addr szBuffP
            .if byte ptr szBuffP[eax-1] == '^'
                  mov     byte ptr szBuffP[eax-1], 0
                  mov     sw5, 1
            .endif
            .if Opt == 1
               INVOKE     lstrlen, addr szBuffW
               .if byte ptr szBuffW[eax-1] == '^'
                     mov     byte ptr szBuffW[eax-1], 0
                     mov     sw5, 1
               .endif
            .endif

            INVOKE     SetDlgItemText, hdlg, E1, addr szBuffN
            INVOKE     SetDlgItemText, hdlg, E2, addr szBuffP
            .if Opt == 1
               INVOKE     SetDlgItemText, hdlg, E3, addr szBuffF
               INVOKE     SetDlgItemText, hdlg, E4, addr szBuffW
            .endif
            INVOKE     GetDlgItem, hdlg, E1      ; Get the handle of the Edit ctl
               mov     ecx, eax
            INVOKE     SetFocus, ecx
         .endif

      .elseif wmsg == WM_CTLCOLORDLG 
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLORSTATIC
         INVOKE     SetBkColor, wparam, 00ffffe0h
         INVOKE     SetTextColor, wparam, 00000000h
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     CreateSolidBrush, 00ffffe0h
            mov     hBR, eax
            ret

      .elseif wmsg == WM_CTLCOLOREDIT
         INVOKE     SetBkColor, wparam, 00000000h   ; Background color is black
         INVOKE     SetTextColor, wparam, 00ffff00h ; Text color of edit box is lt blue
         INVOKE     GetStockObject, BLACK_BRUSH     ; Select the black brush for background
            ret

      .elseif wmsg == WM_CLOSE

EndIt:
         .if hBR
            INVOKE     DeleteObject, hBR
         .endif
         INVOKE     SendMessage, hDlgSav, WM_COMMAND, B1, TempWord1
         INVOKE     EndDialog, hdlg, 0
            mov     eax, TRUE
            jmp     MaintRet

      .elseif wmsg != WM_COMMAND
            jmp     MaintDone
      .endif

         mov     eax, wparam
        cwde
      .if eax == IDCANCEL
            jmp     EndIt

      .elseif eax == B2
         INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
            mov     ofn.lStructSize, sizeof ofn
         INVOKE     lstrcpy, addr szSetUp, addr Patn
         INVOKE     GetCurrentDirectory, lengthof CurDir, addr CurDir
            lea     eax, szSetUp
            mov     ofn.lpstrFile, eax
            mov     ofn.nMaxFile, lengthof szSetUp
            lea     eax, CurDir
            mov     ofn.lpstrInitialDir, eax ;addr CurDir
            mov     ofn.lpstrFilter, 0
            mov     ofn.lpstrTitle, offset szGetHelp
            mov     ofn.Flags, OFN_NOVALIDATE
         INVOKE     GetOpenFileName, addr ofn
            cmp     eax, FALSE         ; Cancel'ed or error occurred
             je     MaintDone
         INVOKE     SetDlgItemText, hdlg, E2, ofn.lpstrFile
            jmp     MaintDone

      .elseif eax == B3
            and     sw4, 0
         INVOKE     GetDlgItemText, hdlg, E1, addr szBuffN, 250
         .if !eax
               jmp     ErrMsg
         .endif
         .if TempWord1 == B7 || TempWord1 == B8
            INVOKE     lstrcpy, addr szWork, addr szSub
            INVOKE     lstrcat,addr szWork, addr szBuffN
            INVOKE     lstrcpy, addr szBuffN, addr szWork
         .endif
         .if TempWord1 != B7 && TempWord1 != B8
            INVOKE     GetDlgItemText, hdlg, E2, addr szBuffP, 250
            .if !eax
                  jmp     ErrMsg
            .endif
            .if sw5 && Opt == 2
               INVOKE     lstrcat, addr szBuffP, addr szCar
            .endif
            .if Opt == 1
               INVOKE     GetDlgItemText, hdlg, E3, addr szBuffF, 63
               .if !eax
                     jmp     ErrMsg
               .endif
               INVOKE     GetDlgItemText, hdlg, E4, addr szBuffW, 63
               .if !eax
                     jmp     ErrMsg
               .endif
               .if sw5
                  INVOKE     lstrcat, addr szBuffW, addr szCar
               .endif
            .endif
         .endif
            mov     sw4, 15
            and     sw5, 0
            jmp     EndIt

      .else
            jmp     MaintDone
      .endif

ErrMsg:
      INVOKE     MessageBox, NULL, addr szSetup, addr AppName, MB_OK or\
                 MB_ICONWARNING or MB_TASKMODAL or MB_TOPMOST

MaintDone:
         mov     eax, FALSE

MaintRet:
         ret
MaintDlg ENDP

;=========================================================================
; Delete and rewrite the menu registry PROCEDURE
;=========================================================================
ReWrite  PROC
LOCAL    lpcbValueName:DWORD, lpcValues, lpdwDisp, lpcbData
LOCAL    dItem:DWORD, Cnt
LOCAL    szWork[256]:BYTE

         INVOKE     RegCloseKey, hKey
         INVOKE     RegDeleteKey, HKEY_CURRENT_USER, offset szMenuItems
         INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, offset szMenuItems, 0, offset szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hKey, addr lpdwDisp

         INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
            mov     Cnt, eax
            mov     dItem, 1
         .if Opt == 1
               mov     mItem, 3101
         .else
               mov     mItem, 7101
         .endif
         .if Cnt
               dec     Cnt
         .endif
         .while (Cnt)
            INVOKE     SendMessage, hList, LB_GETTEXT, dItem, addr szPath
            .if eax != LB_ERR
               INVOKE     wsprintf, addr szIndex, addr fmat4, mItem
               INVOKE     lstrcpy, addr szPath, addr szPath+9
               INVOKE     lstrlen, addr szPath
                  mov     lpcbData, eax
               INVOKE     RegSetValueEx, hKey, addr szName, 0, REG_SZ, addr szPath, lpcbData
            .endif
               inc     dItem
               inc     mItem
               dec     Cnt
         .endw
            dec     mItem
         INVOKE     RegSetValueEx, hKey, addr szMenuCnt, 0, REG_DWORD, addr mItem, 4
            inc     mItem
         INVOKE     LoadMenuItems, 0, 4
         ret
ReWrite ENDP

         END
;INVOKE     MessageBox, NULL, addr szBuff, addr AppName, MB_OK
