         title   ResEditor - DLL Normal Window With (.rc)
         .586
         .model flat, stdcall
            option   casemap: none   ; Case sensitive
            include  \MASM32V1\PROGRAMS\AsmEdit\include\windows.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\user32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\gdi32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\kernel32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\comdlg32.inc
            include  \MASM32V1\PROGRAMS\AsmEdit\include\comctl32.inc

   include  \MASM32V1\PROGRAMS\AsmEdit\include\DSPMACRO.asm

         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\user32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\gdi32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\kernel32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\comdlg32.lib
         includelib  \MASM32V1\PROGRAMS\AsmEdit\lib\comctl32.lib

WinMain        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
TabCtlDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ResourceDlg    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
MenuDlg        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
DialogDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
BuildDlg       PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SampleDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
RichEditProc   PROTO  :DWORD, :DWORD, :DWORD, :DWORD
FillBuffer     PROTO  :DWORD, :DWORD, :BYTE, :DWORD
ControlButt    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
CopyBitMap     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SizeBarProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SizeDataProc   PROTO  :DWORD, :DWORD, :DWORD, :DWORD
BaseAscii      PROTO  :DWORD, :DWORD, :DWORD

.const
EditID         equ 1
IDM_CUT        equ 1005
IDM_COPY       equ 1006
IDM_PASTE      equ 1007
IDM_DEL        equ 1008
IDM_SELALL     equ 1009
IDB_RAD        equ 7001

.data
szTest8        db  'IDB_RAD',0

ClassName      db  'Resource Builder',0
AppName        db  'Resource Builder',0
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
ButtonClass    db  'BUTTON',0
EditClass      db  'EDIT',0
StaticClass    db  'STATIC',0
ButtClass      db  'BUTTON',0

MenuName       db  'MainMenu',0
PopupMenu      db  'PopupMenu',0
FontName       db  'Courier New',0
FontMS         db  'MS Sans Serif',0  ;'Arial',0

szError1       db  'The RICHED20.DLL was not found!',0
szError2       db  'There is a mismatch between the numbers',0dh,0ah
               db  ' of BEGIN and END statements',0

TabTitle1      db  'Resource',0
TabTitle2      db  'Menu',0
TabTitle3      db  'Dialog',0
TabTitle4      db  '    Build    ',0
TabTitle5      db  '   Sample   ',0

szCRLF         db  0dh,0ah,0
szQuote        db  '"',0
szSlashB       db  '\t',0
szCS           db  ', ',0
szEndP         db  '*.*',0
szALL          db  'All Files',0,'*.*',0,0

szResB         db  'BITMAP  DISCARDABLE   ',0
szResI         db  'ICON    DISCARDABLE   ',0
szResC         db  'CURSOR  DISCARDABLE   ',0
szResW         db  'WAVE    DISCARDABLE   ',0
szResM         db  'MIDI    DISCARDABLE   ',0

szMenuN        db  '  MENU DISCARDABLE',0dh,0ah,0dh,0ah
               db  'BEGIN',0dh,0ah,0
szPopup        db  'POPUP ',0
szBegin        db  'BEGIN',0dh,0ah,0
szMenuI        db  'MENUITEM ',0
szSep          db  'MENUITEM SEPERATOR',0dh,0ah,0
szEnd          db  'END',0dh,0ah,0
szFindB        db  'BEGIN',0
szFindE        db  'END',0
szText         db  'Test',0
szNULL         db  0

XNum           db  5 dup(?)
szX            db  ' x ',0 
YNum           db  5 dup(?)


.data?
hInst          dd  ?
hDLL           dd  ?
CommandLine    dd  ?
hREdDll        dd  ?
MainExit       dd  ?
hWnd           dd  ? 
hREdit         dd  ?
lpRichEdit     dd  ?
hWinTab        dd  ?
hFont          dd  ?
hFontS         dd  ?
hSMenu         dd  ?
hMenuN         dd  ?
hCursor        dd  ?
hSizeBar       dd  ?
hSizeData      dd  ?
Cnt            dd  ?
Len            dd  ?
ImageOn        dd  ?
hDC            dd  ?
hSDC           dd  ?
hBR            dd  ?
hBrush         dd  ?
hButtR         dd  ?
hButtC         dd  ?
ButtCnt        dd  ?
hButt          dd  66  dup(?)

SubBmp         dd  ?
NoPaint        dd  ?
SizeOn         dd  ?
PosX           dd  ?
PosY           dd  ?
Lrect          dd  ?
Trect          dd  ?
Rrect          dd  ?
Brect          dd  ?
LockOnX        dd  ?
LockOnY        dd  ?

Test8          dd  ?

hTab           dd  ?
hTabSeL        equ $
hTabSeL1       dd  ?
hTabSeL2       dd  ?
hTabSeL3       dd  ?
hTabSeL4       dd  ?
hTabSeL5       dd  ?
TabSelect      dd  ?

szFill         dd  256 dup(?)
szBuff         db  30  dup(?)

tci            TC_ITEM   <?>
lf             LOGFONT   <?>
rect           RECT      <?>

.code

;________________________________________________________________________________
DllEntry PROC hInstance:DWORD, reason:DWORD, reserved1:DWORD
      .if reason == DLL_PROCESS_ATTACH  ; When the dll is loaded
           push     hInstance
            pop     hInst
            mov     eax, TRUE
      .endif
         ret
DllEntry ENDP

;________________________________________________________________________________
FunctionEntry PROC 

      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls          ; Initialize the common ctrl lib
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax
      .if !eax
         INVOKE     MessageBox, NULL, addr szError1, addr AppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll

NoGo:
;      INVOKE     ExitProcess, MainExit
         ret
FunctionEntry Endp

;________________________________________________________________________________
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG
LOCAL    hwnd:HWND

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW ;CS_HREDRAW or CS_VREDRAW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, 0
         mov     wc.cbWndExtra, 0
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1 ;COLOR_WINDOW+1
         mov     wc.lpszMenuName, 0 ;offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, 0, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, 0
      INVOKE     LoadCursor, 0, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 643
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 450
         shr     eax, 1
         pop     ebx

      INVOKE     CreateWindowEx, WS_EX_TOOLWINDOW or WS_EX_APPWINDOW or WS_EX_CLIENTEDGE,\
                 addr ClassName, addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 643, 450, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

      .while TRUE
         INVOKE     GetMessage, addr msg, 0, 0, 0
         .break .if (!eax)

         INVOKE     IsDialogMessage, hTabSeL2, addr msg
            cmp     eax, 0
            jne     Pass

         INVOKE     TranslateMessage, addr msg
         INVOKE     DispatchMessage, addr msg
Pass:
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;________________________________________________________________________________
WndProc proc  hwnd:DWORD, wMsg, wParam, lParam
LOCAL    cm:COLORMAP
; or WS_CLIPSIBLINGS

      .if wMsg == WM_CREATE
         INVOKE     CreateWindowEx, NULL, addr RichEdit, NULL,\
                    WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or ES_MULTILINE or\
                    WS_HSCROLL or ES_AUTOHSCROLL or WS_VSCROLL or ES_AUTOVSCROLL,\
                    0, 0, 0, 0, hwnd, EditID, hInst, NULL
            mov     hREdit, eax

         INVOKE     SendMessage, hREdit, EM_SETOPTIONS, ECOOP_XOR, ECO_SELECTIONBAR
         INVOKE     SendMessage, hREdit, EM_EXLIMITTEXT, 0, 500000
         INVOKE     SetFocus, hREdit

;---------- [Control window subclassed] ----------
         INVOKE     SetWindowLong, hREdit, GWL_WNDPROC, RichEditProc
            mov     lpRichEdit, eax

         INVOKE     LoadMenu, hInst, addr PopupMenu   
         INVOKE     GetSubMenu, eax, 0
            mov     hSMenu, eax

         INVOKE     CreateDialogParam, hInst, 4000, hwnd, offset TabCtlDlg, 0
            mov     hWinTab, eax

         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
            mov     lf.lfHeight, -12
            mov     lf.lfWeight, 500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFont, eax    ; Edit font

         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontMS
            mov     lf.lfHeight, -8
            mov     lf.lfWeight, 400
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontS, eax   ; SizeBox font

         INVOKE     SendMessage, hREdit, WM_SETFONT, hFont, TRUE
         INVOKE     FillBuffer, addr szFill, sizeof szFill, ' ', 1

;            mov     cm.From, 00c0c0c0h
;         INVOKE     GetSysColor, COLOR_BTNFACE
;            mov     cm.To, eax
;         INVOKE     CreateMappedBitmap, hInst, 801, 0, addr cm, 1 ;CMB_MASKED
;            mov     hButtR, eax
;            mov     cm.From, 00c0c0c0h
;         INVOKE     GetSysColor, COLOR_BTNFACE
;            mov     cm.To, eax
;         INVOKE     CreateMappedBitmap, hInst, 802, 0, addr cm, 1 ;CMB_MASKED
;            mov     hButtC, eax

         INVOKE     LoadImage, hInst, 801, IMAGE_BITMAP, 20, 20, LR_LOADMAP3DCOLORS	
            mov     hButtR, eax
         INVOKE     LoadImage, hInst, 802, IMAGE_BITMAP, 20, 20, LR_LOADMAP3DCOLORS	
            mov     hButtC, eax


      .elseif wMsg == WM_SIZE
         INVOKE     GetWindowRect, hWinTab, addr rect
            mov     eax, rect.left
            sub     rect.right, eax
           push     rect.right
            mov     eax, lParam
            mov     edx, eax
            shr     edx, 16
            and     eax, 0ffffh
            sub     eax, rect.right

         .if edx < 422
              push     eax
            INVOKE     GetWindowRect, hWnd, addr rect
               mov     eax, rect.left
               sub     rect.right, eax
               mov     eax, rect.top
               add     eax, 450
               mov     rect.bottom, eax
            INVOKE     MoveWindow, hWnd, rect.left, rect.top, rect.right, 450, TRUE
               mov     edx, 422
               pop     eax
         .endif
           push     edx
;INVOKE     LockWindowUpdate, hWnd          ; Lock parent to avoid flicker
         INVOKE     MoveWindow, hREdit, 0, 0, eax, edx, TRUE
         INVOKE     GetWindowRect, hwnd, addr rect
            pop     edx
            pop     ecx
            sub     rect.right, ecx
            sub     rect.right, 6
            add     rect.top, 22
         INVOKE     MoveWindow, hWinTab, rect.right, rect.top, ecx, edx, TRUE
         INVOKE     ShowWindow, hWinTab, SW_SHOWDEFAULT
;INVOKE     LockWindowUpdate, 0              ; Unock parent
         INVOKE     SetFocus, hMenuN

      .elseif wMsg == WM_MOVE
         INVOKE     GetClientRect, hWnd, addr rect
            mov     edx, rect.bottom
            shl     edx, 16
            mov     ecx, rect.right
            mov     dx, cx
         INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                         ; Only low word contains command

         .if eax == IDM_CUT
            INVOKE     SendMessage, hREdit, WM_CUT, 0 ,0

         .elseif eax == IDM_COPY
            INVOKE     SendMessage, hREdit, WM_COPY, 0 ,0

         .elseif eax == IDM_PASTE
            INVOKE     SendMessage, hREdit, WM_PASTE, 0 ,0

         .elseif eax == IDM_DEL
            INVOKE     SendMessage, hREdit, WM_CLEAR, 0 ,0

         .elseif eax == IDM_SELALL
            INVOKE     SendMessage, hREdit, EM_SETSEL, 0, -1

         .endif

      .elseif wMsg == WM_DESTROY
        INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

         xor    eax, eax
         ret
WndProc endp

;=========================================================================
; TabCtlDlg Tab Control  DIALOG BOX PROCEDURE
;=========================================================================
TabCtlDlg PROC  hdlg:DWORD, wmsg, wparam, lparam

         cmp     wmsg, WM_INITDIALOG
         jne     NotInit

      INVOKE     GetDlgItem, hdlg, 702            ; Get the handle of the Tab Control
         mov     hTab, eax                        ; Save it

;---------- [Fill the Tab Control Item structure and insert the item] ----------
         mov     tci.imask, TCIF_TEXT             ; Text
         mov     tci.lpReserved1, 0               ; Reserved
         mov     tci.lpReserved2, 0               ; Reserved
         mov     tci.pszText, offset TabTitle1    ; pointer to string containing tab text 
         mov     tci.cchTextMax, sizeof TabTitle1 ; Size of TabTitle1
         mov     tci.iImage, -1                   ; Index to tab control's image 
         mov     tci.lParam, 0                    ; Extra info
      INVOKE     SendMessage, hTab, TCM_INSERTITEM, 0, offset tci

         mov     tci.pszText, offset TabTitle2
         mov     tci.cchTextMax, sizeof TabTitle2
      INVOKE     SendMessage, hTab, TCM_INSERTITEM, 1, addr tci

         mov     tci.pszText, offset TabTitle3
         mov     tci.cchTextMax, sizeof TabTitle3
      INVOKE     SendMessage, hTab, TCM_INSERTITEM, 2, addr tci

         mov     tci.pszText, offset TabTitle4
         mov     tci.cchTextMax, sizeof TabTitle4
      INVOKE     SendMessage, hTab, TCM_INSERTITEM, 3, addr tci

         mov     tci.pszText, offset TabTitle5
         mov     tci.cchTextMax, sizeof TabTitle5
      INVOKE     SendMessage, hTab, TCM_INSERTITEM, 4, addr tci

;---------- [Load the dialog boxes in the Tab Controls] ----------
      INVOKE     CreateDialogParam, hInst, 4801, hTab, offset ResourceDlg, 0
         mov     hTabSeL1, eax

      INVOKE     CreateDialogParam, hInst, 4802, hTab, offset MenuDlg, 0
         mov     hTabSeL2, eax

      INVOKE     CreateDialogParam, hInst, 4803, hTab, offset DialogDlg, 0
         mov     hTabSeL3, eax

      INVOKE     CreateDialogParam, hInst, 4804, hTab, offset BuildDlg, 0
         mov     hTabSeL4, eax

      INVOKE     CreateDialogParam, hInst, 4805, hTab, offset SampleDlg, 0
         mov     hTabSeL5, eax

      INVOKE     SendMessage, hTab, TCM_SETCURSEL, TabSelect, 0
         mov     eax, TabSelect                   ; Previous selected Tab
         mov     ecx, hTabSeL+[eax*4]             ; Extract previous Tabs handle
      INVOKE     ShowWindow, ecx, SW_SHOWDEFAULT
         jmp     GetOut

NotInit:
         cmp     wmsg, WM_NOTIFY
          je     wmnotify
         cmp     wmsg, WM_CLOSE
          je     CancelOut
         cmp     wmsg, WM_COMMAND
         jne     GetOut
         mov     eax, wparam
         cmp     eax, IDCANCEL
          je     CancelOut
         jmp     GetOut

wmnotify:
         mov     eax, lparam                      ; lParam is a pointer to a NMHDR Struct
         mov     eax, (NMHDR ptr [eax]).code      ; Check for TCN_SELCHANGE notify message
         cmp     eax, TCN_SELCHANGE
          je     SelectTab
         jmp     GetOut

SelectTab:
         mov     ecx, TabSelect                   ; Previous selected Tab
         mov     eax, hTabSeL+[ecx*4]             ; Extract previous Tabs handle
      INVOKE     ShowWindow, eax, SW_HIDE         ; Hide its window
      INVOKE     SendMessage, hTab, TCM_GETCURSEL, 0, 0  ; New selected Tab
         mov     TabSelect, eax                   ; Save the Tab ID
         mov     ecx, hTabSeL+[eax*4]             ; Extract new Tabs handle
      INVOKE     ShowWindow, ecx, SW_SHOWDEFAULT  ; Show its window
         jmp     GetOut

CancelOut:
;---------- [Clear any open resources] ----------
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE
         jmp     TabCtlRet

GetOut:
         mov     eax, FALSE

TabCtlRet:
         RET
TabCtlDlg ENDP

;=======================================
; ResourceDlg Dialog
;=======================================
ResourceDlg PROC  uses ebx  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    ofn:OPENFILENAME
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      .if wmsg == WM_INITDIALOG      ; If message is INITDIALOG then

      .elseif wmsg != WM_COMMAND
            jmp     ResourceDone
      .endif

         mov     eax, wparam
        cwde
;701               BITMAP  DISCARDABLE     "\\MASM32V1\\PROGRAMS\\AsmEdit\\Res\\B01_New.bmp"
;IDI_ICON1         ICON    DISCARDABLE     "AsmEdit.ico"
;IDB_TOOLBAR       BITMAP  DISCARDABLE     "AsmEdit.bmp"

      .if eax == 606                     ; Browse
            INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
            INVOKE     lstrcpy, addr szBuff0, addr szEndP
               mov     ofn.lStructSize, sizeof ofn
               mov     ofn.lpstrFilter, offset szALL
               lea     eax, szBuff0
               mov     ofn.lpstrFile, eax
               mov     ofn.nMaxFile, lengthof szBuff0
               mov     ofn.Flags, OFN_NOVALIDATE
            INVOKE     GetOpenFileName, addr ofn
               cmp     eax, FALSE        ; Cancel'ed or error occurred
                je     ResourceDone
            INVOKE     lstrlen, addr szBuff0
               xor     ecx, ecx
               xor     edx, edx
            .while (eax)
                  mov     bl, byte ptr szBuff0[ecx]
                  mov     byte ptr szBuff1[edx], bl
               .if bl == '\'
                     mov     byte ptr szBuff1[edx+1], '\'
                     inc     edx
               .endif
               dec     eax
               inc     ecx
               inc     edx
            .endw
               mov     byte ptr szBuff1[edx], 0
            INVOKE     SetDlgItemText, hdlg, 502, addr szBuff1
               jmp     ResourceDone

      .elseif eax == 607
         INVOKE     GetDlgItemText, hdlg, 501, addr szBuff0, lengthof szBuff0
         .if !eax
               jmp     ResourceDone
         .endif
            mov     edx, 20
            sub     edx, eax
           push     edx
         INVOKE     lstrlen, addr szBuff0
            mov     ecx, eax
            pop     edx
         INVOKE     lstrcpyn, addr szBuff0[ecx], addr szFill, edx
         INVOKE     IsDlgButtonChecked, hdlg, 601
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szResB
         .endif
         INVOKE     IsDlgButtonChecked, hdlg, 602
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szResI
         .endif
         INVOKE     IsDlgButtonChecked, hdlg, 603
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szResC
         .endif
         INVOKE     IsDlgButtonChecked, hdlg, 604
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szResW
         .endif
         INVOKE     IsDlgButtonChecked, hdlg, 605
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szResM
         .endif
          INVOKE     GetDlgItemText, hdlg, 502, addr szBuff1, lengthof szBuff1
         .if !eax
               jmp     ResourceDone
         .endif
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szBuff1
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szCRLF
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0
      .endif

ResourceDone:
         mov     eax, FALSE           ; Return with FALSE

ResourceRet:
         ret
ResourceDlg ENDP

;=======================================
; MenuDlg  Dialog
;=======================================
MenuDlg PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    cr:CHARRANGE
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      .if wmsg == WM_INITDIALOG      ; If message is INITDIALOG then
         INVOKE     GetDlgItem, hdlg, 501
            mov     hMenuN, eax

      .elseif wmsg != WM_COMMAND
            jmp     MenuDone
      .endif

         mov     eax, wparam
        cwde
      .if eax > 602 && eax < 606 && Cnt == 0
            inc     Cnt
      .endif

      .if eax == 601
         INVOKE     GetDlgItemText, hdlg, 501, addr szBuff0, lengthof szBuff0
         INVOKE     lstrcat, addr szBuff0, addr szMenuN
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0

      .elseif eax == 602
            inc     Cnt
         INVOKE     GetDlgItemText, hdlg, 502, addr szBuff1, lengthof szBuff1
            mov     ecx, Cnt
           imul     ecx, 4
            inc     ecx
         INVOKE     lstrcpyn, addr szBuff0, addr szFill, ecx
         INVOKE     lstrcat, addr szBuff0, addr szPopup
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szBuff1
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szCRLF
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0

      .elseif eax == 603
            mov     ecx, Cnt
           imul     ecx, 4
            inc     ecx
         INVOKE     lstrcpyn, addr szBuff0, addr szFill, ecx
         INVOKE     lstrcat, addr szBuff0, addr szBegin
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0

      .elseif eax == 604
         INVOKE     GetDlgItemText, hdlg, 503, addr szBuff1, lengthof szBuff1
            mov     ecx, Cnt
           imul     ecx, 4
            add     ecx,5
         INVOKE     lstrcpyn, addr szBuff0, addr szFill, ecx
         INVOKE     lstrcat, addr szBuff0, addr szMenuI
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szBuff1
         INVOKE     GetDlgItemText, hdlg, 504, addr szBuff1, lengthof szBuff1
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szSlashB
            INVOKE     lstrcat, addr szBuff0, addr szBuff1
         .endif
         INVOKE     lstrcat, addr szBuff0, addr szQuote
         INVOKE     lstrcat, addr szBuff0, addr szCS
         INVOKE     lstrlen, addr szBuff0
         .if eax > Len
               mov     Len, eax
DSPValue hWnd, eax, 1, 't'
         .endif
         INVOKE     GetDlgItemText, hdlg, 505, addr szBuff1, lengthof szBuff1
         INVOKE     lstrcat, addr szBuff0, addr szBuff1
         INVOKE     GetDlgItemText, hdlg, 506, addr szBuff1, lengthof szBuff1
         .if eax
            INVOKE     lstrcat, addr szBuff0, addr szCS
            INVOKE     lstrcat, addr szBuff0, addr szBuff1
         .endif
         INVOKE     lstrcat, addr szBuff0, addr szCRLF
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0

      .elseif eax == 605
            mov     ecx, Cnt
           imul     ecx, 4
            add     ecx,5
         INVOKE     lstrcpyn, addr szBuff0, addr szFill, ecx
         INVOKE     lstrcat, addr szBuff0, addr szSep
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0

      .elseif eax == 606 && Cnt >= 1
            mov     ecx, Cnt
           imul     ecx, 4
            inc     ecx
         INVOKE     lstrcpyn, addr szBuff0, addr szFill, ecx
         INVOKE     lstrcat, addr szBuff0, addr szEnd
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0
            dec     Cnt

      .elseif eax == 607
         INVOKE     lstrcpy, addr szBuff0, addr szEnd
         INVOKE     lstrcat, addr szBuff0, addr szCRLF
         INVOKE     SendMessage, hREdit, EM_SETSEL, -1, 0
         INVOKE     SendMessage, hREdit, EM_REPLACESEL, FALSE, addr szBuff0
            and     Cnt, 0
           call     ChkMatch

      .elseif eax == 608
           call     ChkMatch
         .if eax == -1
               jmp     MenuDone
         .endif

      .endif

MenuDone:
         mov     eax, FALSE           ; Return with FALSE

MenuRet:
         ret
MenuDlg ENDP

;=======================================
; DialogDlg Dialog
;=======================================
DialogDlg PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      .if wmsg == WM_INITDIALOG      ; If message is INITDIALOG then
            jmp     DialogDone

      .elseif wmsg == WM_MOUSEMOVE && NoPaint
;DSPValue hWnd, lparam, 1, 't'

      .elseif wmsg != WM_COMMAND
            jmp     DialogDone
      .endif

         mov     eax, wparam
        cwde

      .if eax == 607
      .endif

DialogDone:
         mov     eax, FALSE           ; Return with FALSE

DialogRet:
         ret
DialogDlg ENDP

;=======================================
; BuildDlg Dialog
;=======================================
BuildDlg PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      .if wmsg == WM_INITDIALOG      ; If message is INITDIALOG then

      .elseif wmsg != WM_COMMAND
            jmp     BuildDone
      .endif

         mov     eax, wparam
        cwde

      .if eax == 607
      .endif

BuildDone:
         mov     eax, FALSE           ; Return with FALSE

BuildRet:
         ret
BuildDlg ENDP

;=======================================
; SampleDlg Dialog
;=======================================
SampleDlg PROC    hdlg:DWORD, wmsg, wparam, lparam
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      .if wmsg == WM_INITDIALOG      ; If message is INITDIALOG then

      .elseif wmsg != WM_COMMAND
            jmp     SampleDone
      .endif

         mov     eax, wparam
        cwde

      .if eax == 607
      .endif

SampleDone:
         mov     eax, FALSE           ; Return with FALSE

SampleRet:
         ret
SampleDlg ENDP

;===================================================
; SubClass the Edit control procedure
;===================================================
RichEditProc PROC hwnd:DWORD, wmsg, wparam, lparam
LOCAL	   pt:POINT
LOCAL	   ps:PAINTSTRUCT
LOCAL    hOldBrush:DWORD, hWDC, hMemDC

      .if wmsg == WM_RBUTTONDOWN
            jmp     PopUp
      .endif
;DSPValue hWnd, lparam, 1, 't'

      .if wmsg == WM_MOUSEMOVE && NoPaint
;DSPValue hWnd, lparam, 1, 't'
      .endif


      .if wmsg == WM_MOVING && NoPaint
;DSPValue hWnd, lparam, 1, 't'
      .endif

;.if NoPaint
;INVOKE     GetCursorPos, addr pt
;DSPValue hWnd, pt.x, 1, 't'
;.endif

;      .if wmsg == WM_PAINT
;         INVOKE     InvalidateRect, hwnd, 0, TRUE
;         INVOKE     BeginPaint, hwnd, ADDR ps
;	      mov	   hWDC, eax
;         INVOKE     EndPaint, hwnd, ADDR ps
;         INVOKE     ReleaseDC, hREdit, hWDC
;            jmp     ThatsAll
;      .endif

      .if wmsg == WM_MOUSEMOVE
         .if wparam != MK_LBUTTON
            .if TabSelect == 2 ;&& ImageOn
                  and     NoPaint, 0
               INVOKE     LoadCursor, 0, IDC_CROSS
                  mov     hCursor, eax
               INVOKE     SetCursor, eax
               INVOKE     GetFocus
               .if eax != hREdit
                  INVOKE     SetFocus, hREdit
               .endif
               INVOKE     HideCaret, hREdit
               INVOKE     SendMessage, hREdit, EM_HIDESELECTION, 1, 0

            .else
                  and     hCursor, 0
               INVOKE     ShowCaret, hREdit
               INVOKE     SendMessage, hREdit, EM_HIDESELECTION, 0, 0
            .endif

         .elseif wparam == MK_LBUTTON && TabSelect == 2 && !NoPaint
            INVOKE     CallWindowProc, lpRichEdit, hwnd, wmsg, wparam, lparam
            INVOKE     SetCapture, hREdit
            INVOKE     LoadCursor, 0, IDC_CROSS
               mov     hCursor, eax
            INVOKE     SetCursor, eax
            xor     ecx, ecx
            mov     eax, lparam
            mov     cx, ax
            shr     eax, 16
            .if ecx > 7fffh
                  mov     ecx, 0
            .endif
            .if ecx < rect.left 
                  inc     ecx
            .endif
            .if eax > 7fffh
                  mov     eax, 0
            .endif
            .if eax < rect.top 
                  inc     eax
            .endif
               mov     rect.right, ecx
               mov     rect.bottom, eax
            INVOKE     RedrawWindow, hREdit, 0, 0,\
                       RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW or RDW_NOCHILDREN
            INVOKE     Rectangle, hDC, rect.left, rect.top, rect.right, rect.bottom
         .endif
      .endif

      .if wmsg == WM_LBUTTONDOWN
         .if hCursor
            INVOKE     HideCaret, hREdit
            INVOKE     GetDC, hREdit
               mov     hDC, eax
            INVOKE     LoadCursor, 0, IDC_CROSS
            INVOKE     SetCursor, eax
               xor     ecx, ecx
               mov     eax, lparam
               mov     cx, ax
               shr     eax, 16
               mov     rect.left, ecx
               mov     rect.top, eax
               and     rect.right, 0
               xor     eax, eax
               ret
         .endif
      .endif

      .if wmsg == WM_LBUTTONUP && rect.right && TabSelect == 2
         INVOKE     ReleaseCapture
         INVOKE     LoadCursor, 0, IDC_CROSS
         INVOKE     SetCursor, eax
         INVOKE     ReleaseDC, hREdit, hDC
            mov     ecx, rect.right
            sub     ecx, rect.left
            mov     edx, rect.bottom
            sub     edx, rect.top
; WS_CLIPSIBLINGS or WS_CLIPCHILDREN  or WS_BORDER or WS_SIZEBOX

         INVOKE     CreateWindowEx, 0, addr ButtClass, 0,
                    WS_CHILD or WS_VISIBLE or BS_OWNERDRAW or WS_BORDER,
                    rect.left, rect.top, ecx, edx, hREdit, 56, hInst, 0
            mov     ecx, eax
            mov     eax, ButtCnt
            mov     hButt+[eax*8+4], ecx    ; Save Button handle
;DSPValue hWnd, ecx, 1, 't'

         INVOKE     SetWindowLong, ecx, GWL_WNDPROC, ControlButt
            mov     SubBmp, eax
      .endif
         jmp     ThatsAll

PopUp:
      INVOKE     GetWindowRect, hWnd, addr rect
         mov     ecx, lparam        ; x/y pos of window
         mov     ebx, ecx
         and     ebx, 0000ffffh     ; ebx = LOWORD(lparam) = x pos
         shr     ecx, 16            ; ecx = HIWORD(lparam) = y pos
         add     ebx, rect.left
         add     ecx, rect.top
         add     ebx, 10 
         add     ecx, 70
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_LEFTBUTTON,\
                 ebx, ecx, 0, hWnd, addr rect
        jmp      ThatsAll

ThatsAll:
      INVOKE     CallWindowProc, lpRichEdit, hwnd, wmsg, wparam, lparam

         ret
RichEditProc ENDP

;===================================================
; ChkMatch procedure
;===================================================
ChkMatch PROC
LOCAL    ft:FINDTEXT
LOCAL    CntB:DWORD, CntE

            and     CntB, 0
            and     CntE, 0
            mov     ft.chrg.cpMin, 0
            mov     ft.chrg.cpMax, -1
            lea     eax, offset szFindB
            mov     ft.lpstrText, eax

FindNextB:
         INVOKE     SendMessage, hREdit, EM_FINDTEXT, FR_DOWN, addr ft
         .if eax != -1
               inc     CntB
               inc     eax
               mov     ft.chrg.cpMin, eax
               jmp     FindNextB
         .endif
            mov     ft.chrg.cpMin, 0
            mov     ft.chrg.cpMax, -1
            lea     eax, offset szFindE
            mov     ft.lpstrText, eax

FindNextE:
         INVOKE     SendMessage, hREdit, EM_FINDTEXT, FR_DOWN, addr ft
         .if eax != -1
               inc     CntE
               inc     eax
               mov     ft.chrg.cpMin, eax
               jmp     FindNextE
         .endif
            mov     eax, CntB
         .if eax != CntE
            INVOKE     MessageBox, NULL, addr szError2, addr AppName, MB_OK
               mov     eax, -1
         .else
               xor     eax, eax
         .endif
         ret
ChkMatch ENDP

;=========================================================================
; Fills a buffer with a character.
;=========================================================================
FillBuffer PROC  uses esi edi  Input:DWORD, SizeB:DWORD, Fill:BYTE, TermA:DWORD
         mov     esi, Input
         mov     edi, esi           ; Dest = Source
         mov     ecx, SizeB         ; Size to fill
         mov     al, Fill           ; Fill character

FillBuff:
       stosb                        ; Store al
        loop     FillBuff           ; for length of string
      .if TermA                     ; Write a terminating char
            dec     edi
            mov     byte ptr[edi], 0
      .endif
         ret
FillBuffer ENDP

;=============================================================================
; Subclass procedure for the Control Buttons
;=============================================================================
ControlButt  PROC  uses ebx esi edi  hCtrl:DWORD, wMsg, wParam, lParam
LOCAL    pt:POINT
LOCAL    Crect:RECT
LOCAL    Erect:RECT
LOCAL    xPos:DWORD, yPos


;.if NoPaint
;INVOKE     GetCursorPos, addr pt
;DSPValue hWnd, pt.x, 1, 't'
;.endif

;      INVOKE     CallWindowProc, SubBmp, hCtrl, wMsg, wParam, lParam
      .if wMsg == WM_PAINT
         .if NoPaint
               mov     eax, 1
               ret
         .endif
         INVOKE     CallWindowProc, SubBmp, hCtrl, wMsg, wParam, lParam

PaintEM:
            mov     eax, hCtrl
;         .if eax == hStatic
            INVOKE     CopyBitMap, hCtrl, hButtR, 20, 20 ;rect.right, rect.bottom ;20, 20
;         .endif
            jmp     Ret0

      .elseif wMsg == WM_LBUTTONDOWN
         INVOKE     SetFocus, hCtrl

      .elseif wMsg == WM_NCLBUTTONDOWN
;INVOKE     GetCursorPos, addr pt
;DSPValue hWnd, pt.x, 1, 't'

      .elseif wMsg == WM_LBUTTONDBLCLK
            mov     NoPaint, 1
         INVOKE     PostMessage, hCtrl, WM_NCLBUTTONDOWN, HTCAPTION, 0

      .elseif wMsg == WM_LBUTTONUP
            and     Test8, 0
            and     LockOnX, 0
            and     LockOnY, 0
         INVOKE     ReleaseCapture
         .if SizeOn
            .if hSizeBar
               INVOKE     SizeBarProc, hSizeBar, WM_COMMAND, IDCANCEL, 0
                  and     hSizeBar, 0
            .endif
            .if hSizeData
               INVOKE     SizeDataProc, hSizeData, WM_COMMAND, IDCANCEL, 0
                  and     hSizeData, 0
            .endif

;DSPValue hWnd, rect.left, 1, 'm'
;DSPValue hWnd, rect.top, 1, 'm'
;DSPValue hWnd, rect.right, 1, 'm'
;DSPValue hWnd, rect.bottom, 1, 'm'
               mov     NoPaint, 1
;            INVOKE     MoveWindow, hCtrl, rect.left, rect.top, rect.right, rect.bottom, TRUE
               and     SizeOn, 0
         .endif

;      .elseif wMsg == WM_NCMOUSEMOVE ;&& NoPaint
;         INVOKE     LoadCursor, 0, IDC_SIZENS
;         INVOKE     SetCursor, eax

      .elseif wMsg == WM_MOUSEMOVE ;&& Test8 == 123456 ;|| WM_NCMOUSEMOVE ;&& NoPaint
         INVOKE     GetClientRect, hCtrl, addr rect
            mov     eax, lParam
            mov     xPos, eax
            mov     yPos, eax
            and     xPos, 0ffffh
            shr     yPos, 16
            mov     eax, hCtrl
            mov     ecx, xPos
            mov     edx, yPos

            add     rect.left, 2
            add     rect.top, 2
            sub     rect.right, 2
            sub     rect.bottom, 2

         .if eax == hCtrl && !NoPaint

            .if !SizeOn
                  and     Lrect, 0
                  and     Trect, 0
                  and     Rrect, 0
                  and     Brect, 0
            .endif

            .if wParam != MK_LBUTTON && !SizeOn
               INVOKE     SetCapture, hCtrl
                  mov     ecx, xPos
                  mov     edx, yPos
                  mov     esi, rect.right
                  add     esi, 4
                  mov     edi, rect.bottom
                  add     edi, 4
               .if edx > rect.top && edx < rect.bottom && !Trect && !Brect && !LockOnY
                  .if ecx > 0fffdh || ecx < rect.left || ecx > rect.right && ecx < esi
                     .if ecx > 0fffch || ecx < rect.left
                           mov     LockOnX, 1
                     .else
                           mov     LockOnX, 2
                     .endif

                     .if !hSizeBar
                        INVOKE     CreateDialogParam, hInst, 4901, hREdit, offset SizeBarProc, 0
                     .endif
                     .if !hSizeData
                        INVOKE     CreateDialogParam, hInst, 4902, hWnd, offset SizeDataProc, 0
                     .endif
                     INVOKE     SetFocus, hCtrl

                     INVOKE     LoadCursor, 0, IDC_SIZEWE
                     INVOKE     SetCursor, eax
                     INVOKE     SetCapture, hCtrl
          
;DSPValue hWnd, xPos, 1, 't'
                  .else
                        and     LockOnX, 0
                        jmp     ResetCur
                  .endif

               .elseif ecx > rect.left && ecx < rect.right && !Lrect && !Rrect && !LockOnX
                  .if edx > 0fffdh || edx < rect.top || edx > rect.bottom && edx < edi
                     .if edx > 0fffch || edx < rect.top
                           mov     LockOnY, 1
                     .else
                           mov     LockOnY, 2
                     .endif

                     .if !hSizeBar
                        INVOKE     CreateDialogParam, hInst, 4901, hREdit, offset SizeBarProc, 0
                     .endif
                     .if !hSizeData
                        INVOKE     CreateDialogParam, hInst, 4902, hWnd, offset SizeDataProc, 0
                     .endif
                     INVOKE     SetFocus, hCtrl

                     INVOKE     LoadCursor, 0, IDC_SIZENS
                     INVOKE     SetCursor, eax
                     INVOKE     SetCapture, hCtrl
;DSPValue hWnd, yPos, 1, 't'
                  .else
                        and     LockOnY, 0
                        jmp     ResetCur
                  .endif

               .else
ResetCur:
;DSPValue hWnd, xPos, 1, 't'
                  INVOKE     LoadCursor, 0, IDC_ARROW
                  INVOKE     SetCursor, eax
                  INVOKE     ReleaseCapture
               .endif
            .endif

            .if wParam == MK_LBUTTON
;               INVOKE     ShowWindow, hSizeData, SW_SHOWDEFAULT

                  mov     ecx, xPos
                  mov     edx, yPos
add     ecx, 2
add     edx, 2

               .if edx > rect.top && edx < rect.bottom && !Trect && !Brect && !LockOnY && LockOnX
                  .if LockOnX == 1 && !Rrect
                        mov     Lrect, ecx
                        mov     SizeOn, 1
                  .elseif  LockOnX == 2 && !Lrect
                        mov     Rrect, ecx
                        mov     SizeOn, 1
                  .endif

               .elseif ecx > rect.left && ecx < rect.right && !Lrect && !Rrect && !LockOnX && LockOnY
                  .if LockOnY == 1 && !Brect
                        mov     Trect, edx
                        mov     SizeOn, 1
                  .elseif  LockOnY == 2 && !Trect
                        mov     Brect, edx
                        mov     SizeOn, 1
                  .endif

               .else

                     and     SizeOn, 0
;                  INVOKE     ShowWindow, hSizeData, SW_HIDE
;                     ret

               .endif

               .if SizeOn

;               INVOKE     BaseAscii, Lnum, addr LNum, 1, 10, 0, 1, 1

               INVOKE     GetCursorPos, addr pt
               INVOKE     ScreenToClient, hCtrl, addr pt
               INVOKE     GetWindowRect, hCtrl, addr rect
                  mov     eax, rect.left
                  mov     ecx, eax
                  add     eax, 6
                  add     pt.x, eax
                  mov     eax, rect.top
                  mov     edx, eax
                  add     eax, 6
                  add     pt.y, eax
                  sub     rect.right, ecx
                  sub     rect.bottom, edx

               INVOKE     BaseAscii, rect.right, addr XNum, 0
               INVOKE     BaseAscii, rect.bottom, addr YNum, 0
               INVOKE     lstrcpy, addr szBuff, addr XNum
               INVOKE     lstrcat, addr szBuff, addr szX
               INVOKE     lstrcat, addr szBuff, addr YNum

               INVOKE     MoveWindow, hSizeData, pt.x, pt.y, 62, 15, 1
               INVOKE     SendMessage, hSizeData, WM_MOUSEMOVE, 0, 0
;DSPValue hWnd, pt.x, 1, 't'



                  INVOKE     GetWindowRect, hREdit, addr Erect
                  INVOKE     GetWindowRect, hCtrl, addr rect
                     mov     eax, rect.left
                     sub     rect.right, eax
                     mov     eax, rect.top
                     sub     rect.bottom, eax

                     mov     eax, Erect.left
                     sub     rect.left, eax
                     mov     eax, Erect.top
                     sub     rect.top, eax
                  .if Rrect
                       push     Rrect
                        pop     rect.right
mov     ebx, Erect.left
add     ebx, rect.left
add     ebx, xPos ;rect.right  ; Works
;DSPValue hWnd, ebx, 1, 't'

                  .elseif Lrect
                       push     Lrect
                        pop     eax
                     .if sword ptr ax < 0
                           neg     eax
                           and     eax, 0ffffh
                           sub     rect.left, eax
                           add     rect.right, eax
                     .else
                           add     rect.left, eax
                           sub     rect.right, eax
                     .endif
mov     ebx, Erect.left
add     ebx, rect.left  ; Works, but doesn't paint right
;DSPValue hWnd, ebx, 1, 't'

                  .elseif Brect
                       push     Brect
                        pop     rect.bottom
                  .elseif Trect
                       push     Trect
                        pop     eax
                     .if sword ptr ax < 0
                           neg     eax
                           and     eax, 0ffffh
                           sub     rect.top, eax
                           add     rect.bottom, eax
                     .else
                           add     rect.top, eax
                           sub     rect.bottom, eax
                     .endif
                  .endif
push     ebx
            INVOKE     GetWindowRect, hCtrl, addr Crect
pop     ebx
            .if Lrect
               mov     ecx, Erect.left
               add     ecx, rect.left
;            .else
;               mov     ecx, Erect.right
;               add     ecx, rect.right
            .endif
               mov     edx, Erect.top
               add     edx, rect.top
;DSPValue hWnd, Crect.top, 1, 't'
;add     Crect.top, 20


;            INVOKE     MoveWindow, hSizeBar, ebx, Crect.top, 1, rect.bottom, TRUE
                  INVOKE     MoveWindow, hCtrl, rect.left, rect.top, rect.right, rect.bottom, TRUE

               .endif
            .endif
         .endif

      .elseif wMsg == WM_MOVING ;&& NoPaint
;INVOKE     GetCursorPos, addr pt
;DSPValue hWnd, pt.x, 1, 't'

      .endif
      INVOKE     CallWindowProc, SubBmp, hCtrl, wMsg, wParam, lParam
         ret

Ret0:
         mov     eax, FALSE
         ret
ControlButt  ENDP

;=============================================================================
; Copies an image to the face of a Button
;=============================================================================
CopyBitMap  PROC hCtrl:DWORD, hBmp, bWh, bHt
LOCAL    hCDC:DWORD, hMemDC, hOldBR

      INVOKE     GetDC, hCtrl                ; Get the dc of the button
         mov     hCDC, eax

      INVOKE     GetClientRect, hCtrl, addr rect
         dec     rect.left
         dec     rect.top
         inc     rect.right
         inc     rect.bottom
      INVOKE     CreateSolidBrush, 00c0c0c0h
         mov     hBR, eax
      INVOKE     SelectObject, hCDC, hBR
;         mov     hOldBR, eax
      INVOKE     Rectangle, hCDC, rect.left, rect.top, rect.right, rect.bottom
      INVOKE     DeleteObject, hBR           ; Delete the brush handle; User Defined 11
;      INVOKE     SelectObject, hCDC, hOldBR

      INVOKE     CreateCompatibleDC, hCDC    ; Create a compatible dc in memory
         mov     hMemDC, eax
      INVOKE     SelectObject, hMemDC, hBmp  ; Select the opened bitmap into the dc
      INVOKE     BitBlt, hCDC, 0, 0, bWh, bHt, hMemDC, 0, 0, SRCCOPY ;Copy the bitmap
      INVOKE     DeleteDC, hMemDC            ; Delete the memory dc
      INVOKE     ReleaseDC, hCtrl, hCDC      ; Release the control dc

         xor    eax, eax
         ret
CopyBitMap  endp

;===================================================
; Splitter Bar PROCEDURE
;===================================================
SizeBarProc PROC  hdlg:DWORD, wmsg, wparam, lparam

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
         mov     eax, hdlg
         mov     hSizeBar, eax
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_CTLCOLORDLG
          je     ColorDlg
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
          je     CancleIt              ; and if not either of these
         jmp     DlgDone

ColorDlg:
      INVOKE     CreateSolidBrush, 000ff00h
         mov     hBrush, eax
         ret

CancleIt:
      INVOKE     DeleteObject, hBrush
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret                           ; Return
SizeBarProc ENDP

;=========================================================================
; SizeDataProc Line Number Box Data PROCEDURE
;=========================================================================
SizeDataProc PROC  hdlg:DWORD, wmsg, wparam, lparam
LOCAL    Clear[20]:BYTE

         cmp     wmsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     NotInit               ; check wmsg
        push     hdlg
         pop     hSizeData
         jmp     DlgDone

NotInit:
         cmp     wmsg, WM_CTLCOLORDLG
          je     ColorDlg
         cmp     wmsg, WM_SETFOCUS
          je     OutPut
         cmp     wmsg, WM_MOUSEMOVE
          je     OutPut
         cmp     wmsg, WM_PAINT
          je     OutPut
         cmp     wmsg, WM_COMMAND      ; Is message a WM_COMMAND?
         mov     eax, wparam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
          je     CancleIt              ; and if not either of these
         jmp     DlgDone

ColorDlg:
      .if hBR
         INVOKE     DeleteObject, hBR
      .endif
      INVOKE     GetSysColor, COLOR_INFOBK
      INVOKE     CreateSolidBrush, eax
         mov     hBR, eax
         ret
 
OutPut:
      INVOKE     GetDC, hdlg
         mov     hSDC, eax
      INVOKE     SelectObject, hSDC, hFontS
      INVOKE     GetClientRect, hdlg, addr rect
         mov     rect.left, 2
         mov     rect.top, 1
         mov     rect.bottom, 16

      INVOKE     FillBuffer, addr Clear, sizeof Clear, ' ', 1
      INVOKE     GetSysColor, COLOR_INFOBK
      INVOKE     SetBkColor, hSDC, eax
      INVOKE     SetTextColor, hSDC, 0 ;TextC
      INVOKE     DrawText, hSDC, addr Clear, 20, addr rect, DT_LEFT or DT_SINGLELINE
      INVOKE     DrawText, hSDC, addr szBuff, -1, addr rect, DT_LEFT or DT_SINGLELINE
      INVOKE     ReleaseDC, hdlg, hSDC
         jmp     DlgDone

CancleIt:
      .if hBR
         INVOKE     DeleteObject, hBR
           and      hBR, 0
      .endif
         and     hSizeData, 0
      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

DlgDone:
         mov     eax, FALSE            ; Return with FALSE

DlgRet:
         ret                           ; Return
SizeDataProc ENDP

;==================================================
;  Converts a 32 bit num value to a  ascii string.
;==================================================
;         INVOKE     BaseAscii, Num, addr szBuff, 0
BaseAscii proc uses edx esi edi InPut:DWORD, OutPut, Fill

         mov     eax, InPut
         mov     edi, OutPut
      .if eax == 0 && !Fill
            mov     byte ptr [edi], '0'
            inc     edi
      .endif
      .if eax < 10 && Fill
            mov     byte ptr [edi], '0'
         .if eax == 0 && Fill
               mov     byte ptr [edi+1], '0'
               inc     edi
         .endif
            inc     edi
      .endif
         mov     esi, edi
         mov     ecx, 10
      .while (eax > 0)
            xor     edx, edx
            div     ecx              ; Put next digit in edx
            add     dl, '0'          ; Convert to ASCII
            mov     [edi], dl        ; Store it
            inc     edi
      .endw
         mov     byte ptr [edi], 0   ; Terminate the string
      .while (esi < edi)
            dec     edi
            mov     al, [esi]
            mov     ah, [edi]
            mov     [edi], al
            mov     [esi], ah
            inc     esi
      .endw
         ret

BaseAscii endp

End DllEntry
;INVOKE     MessageBox, NULL, addr szText, addr AppName, MB_OK
